/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of LibUSB.xs. Do not edit this file, edit LibUSB.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LibUSB.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <libusb.h>

#include "const-c.inc"

typedef libusb_context *USB__LibUSB__XS;
typedef libusb_device *USB__LibUSB__XS__Device;
typedef libusb_device_handle *USB__LibUSB__XS__Device__Handle;

static void
do_not_warn_unused(void *x __attribute__((__unused__)))
{
}

static SV *
ss_ep_comp_to_HV(pTHX_ struct libusb_ss_endpoint_companion_descriptor *ep_comp)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(ep_comp->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(ep_comp->bDescriptorType));
    hv_stores(rv, "bMaxBurst", newSVuv(ep_comp->bMaxBurst));
    hv_stores(rv, "bmAttributes", newSVuv(ep_comp->bmAttributes));
    hv_stores(rv, "wBytesPerInterval", newSVuv(ep_comp->wBytesPerInterval));
    return newRV_noinc((SV *) rv);
}

static SV *
endpoint_descriptor_to_HV(pTHX_ libusb_context *ctx, const struct libusb_endpoint_descriptor *endpoint)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(endpoint->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(endpoint->bDescriptorType));
    hv_stores(rv, "bEndpointAddress", newSVuv(endpoint->bEndpointAddress));
    hv_stores(rv, "bmAttributes", newSVuv(endpoint->bmAttributes));
    hv_stores(rv, "wMaxPacketSize", newSVuv(endpoint->wMaxPacketSize));
    hv_stores(rv, "bInterval", newSVuv(endpoint->bInterval));
    hv_stores(rv, "bRefresh", newSVuv(endpoint->bRefresh));
    hv_stores(rv, "bSynchAddress", newSVuv(endpoint->bSynchAddress));
    hv_stores(rv, "extra", newSVpvn((const char *)endpoint->extra, endpoint->extra_length));
  
    struct libusb_ss_endpoint_companion_descriptor *ep_comp;
    int value = libusb_get_ss_endpoint_companion_descriptor(ctx, endpoint, &ep_comp);
    if (value == 0) {
        hv_stores(rv, "ss_endpoint_companion", ss_ep_comp_to_HV(aTHX_ ep_comp));
        libusb_free_ss_endpoint_companion_descriptor(ep_comp);
    }
    else if (value != LIBUSB_ERROR_NOT_FOUND)
        croak("Error in libusb_get_ss_endpoint_companion_descriptor");
    return newRV_noinc((SV *) rv);
}

static SV *
endpoint_array_to_AV(pTHX_ libusb_context *ctx, const struct libusb_endpoint_descriptor *endpoint, int num_endpoints)
{
    AV *rv = newAV();
    for (int i = 0; i < num_endpoints; ++i)
        av_push(rv, endpoint_descriptor_to_HV(aTHX_ ctx, &endpoint[i]));
    return newRV_noinc((SV *) rv);
}


static SV *
interface_descriptor_to_HV(pTHX_ libusb_context *ctx, const struct libusb_interface_descriptor *interface)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(interface->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(interface->bDescriptorType));
    hv_stores(rv, "bInterfaceNumber", newSVuv(interface->bInterfaceNumber));
    hv_stores(rv, "bAlternateSetting", newSVuv(interface->bAlternateSetting));
    hv_stores(rv, "bNumEndpoints", newSVuv(interface->bNumEndpoints));
    hv_stores(rv, "bInterfaceClass", newSVuv(interface->bInterfaceClass));
    hv_stores(rv, "bInterfaceSubClass", newSVuv(interface->bInterfaceSubClass));
    hv_stores(rv, "bInterfaceProtocol", newSVuv(interface->bInterfaceProtocol));
    hv_stores(rv, "iInterface", newSVuv(interface->iInterface));
    hv_stores(rv, "endpoint", endpoint_array_to_AV(aTHX_ ctx, interface->endpoint, interface->bNumEndpoints));
    hv_stores(rv, "extra", newSVpvn((const char *) interface->extra, interface->extra_length));
    return newRV_noinc((SV *) rv);
}

static SV *
altsetting_array_to_AV(pTHX_ libusb_context *ctx, const struct libusb_interface *interface)
{
    AV *rv = newAV();
    for (int i = 0; i < interface->num_altsetting; ++i)
        av_push(rv, interface_descriptor_to_HV(aTHX_ ctx, &interface->altsetting[i]));
    return newRV_noinc((SV *) rv);  
}

static SV *
interface_array_to_AV(pTHX_ libusb_context *ctx, const struct libusb_interface *interface, int num_interfaces)
{
    AV *rv = newAV();
    for (int i = 0; i < num_interfaces; ++i)
        av_push(rv, altsetting_array_to_AV(aTHX_ ctx, &interface[i]));
    return newRV_noinc((SV *) rv);
}

static SV *
config_descriptor_to_RV(pTHX_ libusb_context *ctx, struct libusb_config_descriptor *config)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(config->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(config->bDescriptorType));
    hv_stores(rv, "wTotalLength", newSVuv(config->wTotalLength));
    hv_stores(rv, "bNumInterfaces", newSVuv(config->bNumInterfaces));
    hv_stores(rv, "bConfigurationValue", newSVuv(config->bConfigurationValue));
    hv_stores(rv, "iConfiguration", newSVuv(config->iConfiguration));
    hv_stores(rv, "bmAttributes", newSVuv(config->bmAttributes));
    hv_stores(rv, "MaxPower", newSVuv(config->MaxPower));
    hv_stores(rv, "interface", interface_array_to_AV(aTHX_ ctx, config->interface, config->bNumInterfaces));
    hv_stores(rv, "extra", newSVpvn((const char *) config->extra, config->extra_length));
    return newRV_noinc((SV *) rv);
}

static SV *
usb_2_0_extension_to_HV(pTHX_ libusb_context *ctx, struct libusb_bos_dev_capability_descriptor *dev_cap)
{
    struct libusb_usb_2_0_extension_descriptor *usb_2_0_extension;
    int value =  libusb_get_usb_2_0_extension_descriptor(ctx, dev_cap, &usb_2_0_extension);
    if (value != 0)
        croak("error in libusb_get_usb_2_0_extension_descriptor");
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(usb_2_0_extension->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(usb_2_0_extension->bDescriptorType));
    hv_stores(rv, "bDevCapabilityType", newSVuv(usb_2_0_extension->bDevCapabilityType));
    hv_stores(rv, "bmAttributes", newSVuv(usb_2_0_extension->bmAttributes));
    libusb_free_usb_2_0_extension_descriptor(usb_2_0_extension);
    return newRV_noinc((SV *) rv);
}

static SV *
ss_usb_device_capability_to_HV(pTHX_ libusb_context *ctx, struct libusb_bos_dev_capability_descriptor *dev_cap)
{
    struct libusb_ss_usb_device_capability_descriptor *ss_usb_device_capability;
    int value =  libusb_get_ss_usb_device_capability_descriptor(ctx, dev_cap, &ss_usb_device_capability);
    if (value != 0)
        croak("error in libusb_get_ss_usb_device_capability_descriptor");
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(ss_usb_device_capability->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(ss_usb_device_capability->bDescriptorType));
    hv_stores(rv, "bDevCapabilityType", newSVuv(ss_usb_device_capability->bDevCapabilityType));
    hv_stores(rv, "bmAttributes", newSVuv(ss_usb_device_capability->bmAttributes));
    hv_stores(rv, "wSpeedSupported", newSVuv(ss_usb_device_capability->wSpeedSupported));
    hv_stores(rv, "bFunctionalitySupport", newSVuv(ss_usb_device_capability->bFunctionalitySupport));
    hv_stores(rv, "bU1DevExitLat", newSVuv(ss_usb_device_capability->bU1DevExitLat));
    hv_stores(rv, "bU2DevExitLat", newSVuv(ss_usb_device_capability->bU2DevExitLat));
    libusb_free_ss_usb_device_capability_descriptor(ss_usb_device_capability);
    return newRV_noinc((SV *) rv);
}

static SV *
container_id_to_HV(pTHX_ libusb_context *ctx, struct libusb_bos_dev_capability_descriptor *dev_cap)
{
    struct libusb_container_id_descriptor *container_id;
    int value =  libusb_get_container_id_descriptor(ctx, dev_cap, &container_id);
    if (value != 0)
        croak("error in libusb_get_container_id_descriptor");
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(container_id->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(container_id->bDescriptorType));
    hv_stores(rv, "bDevCapabilityType", newSVuv(container_id->bDevCapabilityType));
    hv_stores(rv, "bReserved", newSVuv(container_id->bReserved));
    hv_stores(rv, "ContainerID", newSVpvn((const char *) container_id->ContainerID, 16));
    libusb_free_container_id_descriptor(container_id);
    return newRV_noinc((SV *) rv);
}

static SV *
bos_dev_capability_descriptor_to_HV(pTHX_ libusb_context *ctx, struct libusb_bos_dev_capability_descriptor *dev_cap)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(dev_cap->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(dev_cap->bDescriptorType));
    unsigned capability_type = dev_cap->bDevCapabilityType;
    hv_stores(rv, "bDevCapabilityType", newSVuv(capability_type));
    hv_stores(rv, "dev_capability_data", newSVpvn((const char *) dev_cap->dev_capability_data, dev_cap->bLength - 3));
    switch (capability_type) {
        case LIBUSB_BT_USB_2_0_EXTENSION:
            hv_stores(rv, "usb_2_0_extension", usb_2_0_extension_to_HV(aTHX_ ctx, dev_cap));
            break;
        case LIBUSB_BT_SS_USB_DEVICE_CAPABILITY:
            hv_stores(rv, "ss_usb_device_capability", ss_usb_device_capability_to_HV(aTHX_ ctx, dev_cap));
            break;
        case LIBUSB_BT_CONTAINER_ID:
            hv_stores(rv, "container_id", container_id_to_HV(aTHX_ ctx, dev_cap));
            break;
    }
    
    return newRV_noinc((SV *) rv);
}

static SV *
dev_capability_array_to_AV(pTHX_ libusb_context *ctx, struct libusb_bos_dev_capability_descriptor **dev_capability, uint8_t bNumDeviceCaps)
{
    AV *rv = newAV();
    for (int i = 0; i < bNumDeviceCaps; ++i)
        av_push(rv, bos_dev_capability_descriptor_to_HV(aTHX_ ctx, dev_capability[i]));
    return newRV_noinc((SV *) rv);
}

static SV *
bos_descriptor_to_RV(pTHX_ libusb_context *ctx, struct libusb_bos_descriptor *bos)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(bos->bLength));
    hv_stores(rv, "bDescriptorType", newSVuv(bos->bDescriptorType));
    hv_stores(rv, "wTotalLength", newSVuv(bos->wTotalLength));
    hv_stores(rv, "bNumDeviceCaps", newSVuv(bos->bNumDeviceCaps));
    hv_stores(rv, "dev_capability", dev_capability_array_to_AV(aTHX_ ctx, bos->dev_capability, bos->bNumDeviceCaps));
    return newRV_noinc((SV *) rv);
}


static SV *
device_descriptor_to_RV(pTHX_ struct libusb_device_descriptor *desc)
{
    HV *rv = newHV();
    hv_stores(rv, "bLength", newSVuv(desc->bLength));    
    hv_stores(rv, "bDescriptorType", newSVuv(desc->bDescriptorType));
    hv_stores(rv, "bcdUSB", newSVuv(desc->bcdUSB));
    hv_stores(rv, "bDeviceClass", newSVuv(desc->bDeviceClass));
    hv_stores(rv, "bDeviceSubClass", newSVuv(desc->bDeviceSubClass));
    hv_stores(rv, "bDeviceProtocol", newSVuv(desc->bDeviceProtocol));
    hv_stores(rv, "bMaxPacketSize0", newSVuv(desc->bMaxPacketSize0));
    hv_stores(rv, "idVendor", newSVuv(desc->idVendor));
    hv_stores(rv, "idProduct", newSVuv(desc->idProduct));
    hv_stores(rv, "bcdDevice", newSVuv(desc->bcdDevice));
    hv_stores(rv, "iManufacturer", newSVuv(desc->iManufacturer));
    hv_stores(rv, "iProduct", newSVuv(desc->iProduct));
    hv_stores(rv, "iSerialNumber", newSVuv(desc->iSerialNumber));
    hv_stores(rv, "bNumConfigurations", newSVuv(desc->bNumConfigurations));
    return newRV_noinc((SV *) rv);
}

static SV *
version_to_RV(pTHX_ const struct libusb_version *version)
{
    HV *rv = newHV();
    hv_stores(rv, "major", newSVuv(version->major));
    hv_stores(rv, "minor", newSVuv(version->minor));
    hv_stores(rv, "micro", newSVuv(version->micro));
    hv_stores(rv, "nano", newSVuv(version->nano));
    hv_stores(rv, "rc", newSVpv(version->rc, 0));
    // "describe" key is for ABI compatibilty only => do not implement
    return newRV_noinc((SV *) rv);
}

static SV *
pointer_object(pTHX_ const char *class_name, void *pv)
{
    SV *rv = newSV(0);
    sv_setref_pv(rv, class_name, pv);
    return rv;
}




#line 275 "LibUSB.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 419 "LibUSB.c"

/* INCLUDE:  Including 'const-xs.inc' from 'LibUSB.xs' */


XS_EUPXS(XS_USB__LibUSB__XS_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 444 "LibUSB.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid USB::LibUSB::XS macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined USB::LibUSB::XS macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing USB::LibUSB::XS macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 522 "LibUSB.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'LibUSB.xs' from 'const-xs.inc' */


XS_EUPXS(XS_USB__LibUSB__XS_set_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_set_debug)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ctx, level");
    {
	USB__LibUSB__XS	ctx;
	int	level = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::set_debug",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(0)
		);
	}
;

	libusb_set_debug(ctx, level);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
#line 284 "LibUSB.xs"
    libusb_context *ctx;
    int rv = libusb_init(&ctx);
    mXPUSHi(rv);
    if (rv == 0)
        mXPUSHs(pointer_object(aTHX_ class, ctx));
#line 580 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS_exit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_exit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	USB__LibUSB__XS	ctx;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::exit",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(0)
		);
	}
;

	libusb_exit(ctx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	USB__LibUSB__XS	ctx;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"USB::LibUSB::XS::DESTROY",
			"ctx")
;
#line 296 "LibUSB.xs"
    do_not_warn_unused(ctx);
#line 636 "LibUSB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS_get_device_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_get_device_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS	ctx;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::get_device_list",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(0)
		);
	}
;
#line 313 "LibUSB.xs"
    libusb_device **list;
    ssize_t num = libusb_get_device_list(ctx, &list);
    mXPUSHi(num);
    ssize_t i;
    for (i = 0; i < num; ++i) {
        SV *tmp = newSV(0);
        sv_setref_pv(tmp, "USB::LibUSB::XS::Device", (void *) list[i]);
        mXPUSHs(tmp);
    }
    if (num >= 0)
        libusb_free_device_list(list, 0);
#line 678 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"USB::LibUSB::XS::Device::DESTROY",
			"dev")
;
#line 332 "LibUSB.xs"
    do_not_warn_unused(dev);
#line 705 "LibUSB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_bus_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_bus_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	unsigned	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_bus_number",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_bus_number(dev);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_port_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_port_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	unsigned	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_port_number",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_port_number(dev);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_port_numbers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_port_numbers)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_port_numbers",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;
#line 343 "LibUSB.xs"
    int len = 20;
    uint8_t port_numbers[len];
    int num = libusb_get_port_numbers(dev, port_numbers, len);
    mXPUSHi(num);
    int i;
    for (i = 0; i < num; ++i) {
        mXPUSHu(port_numbers[i]);
    }
#line 810 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_parent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	USB__LibUSB__XS__Device	RETVAL;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_parent",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_parent(dev);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "USB::LibUSB::XS::Device", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_address)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	unsigned	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_device_address",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_device_address(dev);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_speed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_device_speed",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_device_speed(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_max_packet_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_max_packet_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, endpoint");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;
	unsigned char	endpoint = (unsigned char)SvUV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_max_packet_size",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_max_packet_size(dev, endpoint);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_max_iso_packet_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_max_iso_packet_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, endpoint");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device	dev;
	unsigned char	endpoint = (unsigned char)SvUV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_max_iso_packet_size",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_max_iso_packet_size(dev, endpoint);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_ref_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_ref_device)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	USB__LibUSB__XS__Device	RETVAL;
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::ref_device",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_ref_device(dev);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "USB::LibUSB::XS::Device", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_unref_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_unref_device)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::unref_device",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	libusb_unref_device(dev);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::open",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;
#line 384 "LibUSB.xs"
    libusb_device_handle *handle;
    int rv = libusb_open(dev, &handle);
    mXPUSHi(rv);
    if (rv == 0)
        mXPUSHs(pointer_object(aTHX_ "USB::LibUSB::XS::Device::Handle", handle));
#line 1084 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS_open_device_with_vid_pid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_open_device_with_vid_pid)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ctx, vendor_id, product_id");
    {
	USB__LibUSB__XS__Device__Handle	RETVAL;
	USB__LibUSB__XS	ctx;
	unsigned	vendor_id = (unsigned)SvUV(ST(1))
;
	unsigned	product_id = (unsigned)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::open_device_with_vid_pid",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_open_device_with_vid_pid(ctx, vendor_id, product_id);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "USB::LibUSB::XS::Device::Handle", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	USB__LibUSB__XS__Device__Handle	handle;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"USB::LibUSB::XS::Device::Handle::DESTROY",
			"handle")
;
#line 400 "LibUSB.xs"
    do_not_warn_unused(handle);
#line 1151 "LibUSB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	USB__LibUSB__XS__Device__Handle	handle;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::close",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	libusb_close(handle);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_device)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev_handle");
    {
	USB__LibUSB__XS__Device	RETVAL;
	USB__LibUSB__XS__Device__Handle	dev_handle;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev_handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_device",
			"dev_handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_get_device(dev_handle);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "USB::LibUSB::XS::Device", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_configuration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_configuration)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_configuration",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 413 "LibUSB.xs"
    int config;
    int rv = libusb_get_configuration(dev, &config);
    mXPUSHi(rv);
    if (rv == 0)
        mXPUSHi(config);
#line 1252 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_configuration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_configuration)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, configuration");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	configuration = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::set_configuration",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_set_configuration(dev, configuration);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_claim_interface); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_claim_interface)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, interface_number");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::claim_interface",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_claim_interface(dev, interface_number);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_release_interface); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_release_interface)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, interface_number");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::release_interface",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_release_interface(dev, interface_number);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_interface_alt_setting); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_interface_alt_setting)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, interface_number, alternate_setting");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;
	int	alternate_setting = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::set_interface_alt_setting",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_set_interface_alt_setting(dev, interface_number, alternate_setting);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_clear_halt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_clear_halt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, endpoint");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	unsigned	endpoint = (unsigned)SvUV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::clear_halt",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_clear_halt(dev, endpoint);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_reset_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_reset_device)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::reset_device",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_reset_device(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_kernel_driver_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_kernel_driver_active)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, interface_number");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::kernel_driver_active",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_kernel_driver_active(dev, interface_number);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_detach_kernel_driver); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_detach_kernel_driver)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, interface_number");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::detach_kernel_driver",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_detach_kernel_driver(dev, interface_number);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_attach_kernel_driver); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_attach_kernel_driver)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, interface_number");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	interface_number = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::attach_kernel_driver",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_attach_kernel_driver(dev, interface_number);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_auto_detach_kernel_driver); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_set_auto_detach_kernel_driver)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, enable");
    {
	int	RETVAL;
	dXSTARG;
	USB__LibUSB__XS__Device__Handle	dev;
	int	enable = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::set_auto_detach_kernel_driver",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	RETVAL = libusb_set_auto_detach_kernel_driver(dev, enable);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS_libusb_has_capability); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_libusb_has_capability)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "capability");
    {
	int	RETVAL;
	dXSTARG;
	unsigned	capability = (unsigned)SvUV(ST(0))
;

	RETVAL = libusb_has_capability(capability);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS_libusb_error_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_libusb_error_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "error_code");
    {
	const char *	RETVAL;
	dXSTARG;
	int	error_code = (int)SvIV(ST(0))
;

	RETVAL = libusb_error_name(error_code);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS_libusb_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_libusb_get_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 469 "LibUSB.xs"
    const struct libusb_version *version = libusb_get_version();
    mXPUSHs(version_to_RV(aTHX_ version));
#line 1662 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS_libusb_setlocale); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_libusb_setlocale)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "locale");
    {
	int	RETVAL;
	dXSTARG;
	const char *	locale = (const char *)SvPV_nolen(ST(0))
;

	RETVAL = libusb_setlocale(locale);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS_libusb_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS_libusb_strerror)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "error_code");
    {
	const char *	RETVAL;
	dXSTARG;
	int	error_code = (int)SvIV(ST(0))
;

	RETVAL = libusb_strerror(error_code);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_device_descriptor)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_device_descriptor",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;
#line 490 "LibUSB.xs"
    struct libusb_device_descriptor desc;
    int rv = libusb_get_device_descriptor(dev, &desc);
    mXPUSHi(rv);
    // Function always succeeds since libusb 1.0.16
    mXPUSHs(device_descriptor_to_RV(aTHX_ &desc));
#line 1740 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_active_config_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_active_config_descriptor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;
	USB__LibUSB__XS	ctx;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_active_config_descriptor",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_active_config_descriptor",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(1)
		);
	}
;
#line 502 "LibUSB.xs"
    struct libusb_config_descriptor *config;
    int rv = libusb_get_active_config_descriptor(dev, &config);
    mXPUSHi(rv);
    if (rv == 0)
        mXPUSHs(config_descriptor_to_RV(aTHX_ ctx, config));
#line 1792 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_config_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_config_descriptor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, ctx, config_index");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;
	USB__LibUSB__XS	ctx;
	unsigned	config_index = (unsigned)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_config_descriptor",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_config_descriptor",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(1)
		);
	}
;
#line 512 "LibUSB.xs"
    struct libusb_config_descriptor *config;
    int rv = libusb_get_config_descriptor(dev, config_index, &config);
    mXPUSHi(rv);
    if (rv == 0) {
        mXPUSHs(config_descriptor_to_RV(aTHX_ ctx, config));
        libusb_free_config_descriptor(config);
    }
#line 1848 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device_get_config_descriptor_by_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device_get_config_descriptor_by_value)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, ctx, bConfigurationValue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device	dev;
	USB__LibUSB__XS	ctx;
	unsigned	bConfigurationValue = (unsigned)SvUV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_config_descriptor_by_value",
			"dev", "USB::LibUSB::XS::Device",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::get_config_descriptor_by_value",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(1)
		);
	}
;
#line 524 "LibUSB.xs"
    struct libusb_config_descriptor *config;
    int rv = libusb_get_config_descriptor_by_value(dev, bConfigurationValue, &config);
    mXPUSHi(rv);
    if (rv == 0) {
        mXPUSHs(config_descriptor_to_RV(aTHX_ ctx, config));
        libusb_free_config_descriptor(config);
    }
#line 1904 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_bos_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_bos_descriptor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, ctx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	USB__LibUSB__XS	ctx;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_bos_descriptor",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "USB::LibUSB::XS")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ctx = INT2PTR(USB__LibUSB__XS,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_bos_descriptor",
			"ctx", "USB::LibUSB::XS",
			refstr, ST(1)
		);
	}
;
#line 539 "LibUSB.xs"
    struct libusb_bos_descriptor *bos;
    int rv = libusb_get_bos_descriptor(handle, &bos);
    mXPUSHi(rv);
    if (rv == 0) {
        mXPUSHs(bos_descriptor_to_RV(aTHX_ ctx, bos));
        libusb_free_bos_descriptor(bos);
    }
#line 1958 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor_ascii); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor_ascii)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, desc_index, length");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	dev;
	unsigned	desc_index = (unsigned)SvUV(ST(1))
;
	int	length = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_string_descriptor_ascii",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 551 "LibUSB.xs"
    char *buffer;
    Newx(buffer, length, char);
    int rv = libusb_get_string_descriptor_ascii(dev, desc_index, (unsigned char *) buffer, length);
    mXPUSHi(rv);
    if (rv >= 0)
        mXPUSHp(buffer, rv);
    Safefree(buffer);
#line 2001 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_descriptor)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, desc_type, desc_index, length");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	dev;
	unsigned	desc_type = (unsigned)SvUV(ST(1))
;
	unsigned	desc_index = (unsigned)SvUV(ST(2))
;
	int	length = (int)SvIV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_descriptor",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 563 "LibUSB.xs"
    char *buffer;
    Newx(buffer, length, char);
    int rv = libusb_get_descriptor(dev, desc_type, desc_index, (unsigned char *) buffer, length);
    mXPUSHi(rv);
    if (rv >= 0)
        mXPUSHp(buffer, rv);
    Safefree(buffer);
#line 2046 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, desc_index, langid, length");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	dev;
	unsigned	desc_index = (unsigned)SvUV(ST(1))
;
	unsigned	langid = (unsigned)SvUV(ST(2))
;
	int	length = (int)SvIV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::get_string_descriptor",
			"dev", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 575 "LibUSB.xs"
    char *buffer;
    Newx(buffer, length, char);
    int rv = libusb_get_string_descriptor(dev, desc_index, langid, (unsigned char *) buffer, length);
    mXPUSHi(rv);
    if (rv >= 0)
        mXPUSHp(buffer, rv);
    Safefree(buffer);
#line 2091 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_control_transfer_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_control_transfer_write)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "handle, bmRequestType, bRequest, wValue, wIndex, data, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	bmRequestType = (unsigned)SvUV(ST(1))
;
	unsigned	bRequest = (unsigned)SvUV(ST(2))
;
	unsigned	wValue = (unsigned)SvUV(ST(3))
;
	unsigned	wIndex = (unsigned)SvUV(ST(4))
;
	SV *	data = ST(5)
;
	unsigned	timeout = (unsigned)SvUV(ST(6))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::control_transfer_write",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 606 "LibUSB.xs"
    const char *bytes;
    STRLEN len;
    bytes = SvPV(data, len);
    if (len == 0)
        bytes = NULL;
    mXPUSHi(libusb_control_transfer(handle, bmRequestType, bRequest, wValue, wIndex, (unsigned char *) bytes, len, timeout));
#line 2141 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_control_transfer_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_control_transfer_read)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "handle, bmRequestType, bRequest, wValue, wIndex, length, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	bmRequestType = (unsigned)SvUV(ST(1))
;
	unsigned	bRequest = (unsigned)SvUV(ST(2))
;
	unsigned	wValue = (unsigned)SvUV(ST(3))
;
	unsigned	wIndex = (unsigned)SvUV(ST(4))
;
	unsigned	length = (unsigned)SvUV(ST(5))
;
	unsigned	timeout = (unsigned)SvUV(ST(6))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::control_transfer_read",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 616 "LibUSB.xs"
    char *data;
    Newx(data, length, char);
    int rv = libusb_control_transfer(handle, bmRequestType, bRequest, wValue, wIndex, (unsigned char *) data, length, timeout);
    mXPUSHi(rv);
    if (rv >= 0)
        mXPUSHp(data, rv);
    Safefree(data);
#line 2192 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_write)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, endpoint, data, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	endpoint = (unsigned)SvUV(ST(1))
;
	SV *	data = ST(2)
;
	unsigned	timeout = (unsigned)SvUV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::bulk_transfer_write",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 628 "LibUSB.xs"
    STRLEN len;
    const char *bytes = SvPV(data, len);
    int transferred;
    int rv = libusb_bulk_transfer(handle, endpoint, (unsigned char *) bytes, len, &transferred, timeout);
    mXPUSHi(rv);
    if (rv == 0 || rv == LIBUSB_ERROR_TIMEOUT)
        mXPUSHi(transferred);
#line 2237 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_read)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, endpoint, length, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	endpoint = (unsigned)SvUV(ST(1))
;
	int	length = (int)SvIV(ST(2))
;
	unsigned	timeout = (unsigned)SvUV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::bulk_transfer_read",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 640 "LibUSB.xs"
    char *data;
    Newx(data, length, char);
    int transferred;
    int rv = libusb_bulk_transfer(handle, endpoint, (unsigned char *) data, length, &transferred, timeout);
    mXPUSHi(rv);
    if (rv == 0 || rv == LIBUSB_ERROR_TIMEOUT)
        mXPUSHp(data, transferred);
    Safefree(data);
#line 2283 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_write)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, endpoint, data, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	endpoint = (unsigned)SvUV(ST(1))
;
	SV *	data = ST(2)
;
	unsigned	timeout = (unsigned)SvUV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::interrupt_transfer_write",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 653 "LibUSB.xs"
    STRLEN len;
    const char *bytes = SvPV(data, len);
    int transferred;
    int rv = libusb_interrupt_transfer(handle, endpoint, (unsigned char *) bytes, len, &transferred, timeout);
    mXPUSHi(rv);
    if (rv == 0 || rv == LIBUSB_ERROR_TIMEOUT)
        mXPUSHi(transferred);
#line 2328 "LibUSB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_read)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, endpoint, length, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	USB__LibUSB__XS__Device__Handle	handle;
	unsigned	endpoint = (unsigned)SvUV(ST(1))
;
	int	length = (int)SvIV(ST(2))
;
	unsigned	timeout = (unsigned)SvUV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "USB::LibUSB::XS::Device::Handle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = INT2PTR(USB__LibUSB__XS__Device__Handle,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"USB::LibUSB::XS::Device::Handle::interrupt_transfer_read",
			"handle", "USB::LibUSB::XS::Device::Handle",
			refstr, ST(0)
		);
	}
;
#line 665 "LibUSB.xs"
    char *data;
    Newx(data, length, char);
    int transferred;
    int rv = libusb_interrupt_transfer(handle, endpoint, (unsigned char *) data, length, &transferred, timeout);
    mXPUSHi(rv);
    if (rv == 0 || rv == LIBUSB_ERROR_TIMEOUT)
        mXPUSHp(data, transferred);
    Safefree(data);
#line 2374 "LibUSB.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_USB__LibUSB); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_USB__LibUSB)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("USB::LibUSB::XS::constant", XS_USB__LibUSB__XS_constant);
        newXS_deffile("USB::LibUSB::XS::set_debug", XS_USB__LibUSB__XS_set_debug);
        newXS_deffile("USB::LibUSB::XS::init", XS_USB__LibUSB__XS_init);
        newXS_deffile("USB::LibUSB::XS::exit", XS_USB__LibUSB__XS_exit);
        newXS_deffile("USB::LibUSB::XS::DESTROY", XS_USB__LibUSB__XS_DESTROY);
        newXS_deffile("USB::LibUSB::XS::get_device_list", XS_USB__LibUSB__XS_get_device_list);
        newXS_deffile("USB::LibUSB::XS::Device::DESTROY", XS_USB__LibUSB__XS__Device_DESTROY);
        newXS_deffile("USB::LibUSB::XS::Device::get_bus_number", XS_USB__LibUSB__XS__Device_get_bus_number);
        newXS_deffile("USB::LibUSB::XS::Device::get_port_number", XS_USB__LibUSB__XS__Device_get_port_number);
        newXS_deffile("USB::LibUSB::XS::Device::get_port_numbers", XS_USB__LibUSB__XS__Device_get_port_numbers);
        newXS_deffile("USB::LibUSB::XS::Device::get_parent", XS_USB__LibUSB__XS__Device_get_parent);
        newXS_deffile("USB::LibUSB::XS::Device::get_device_address", XS_USB__LibUSB__XS__Device_get_device_address);
        newXS_deffile("USB::LibUSB::XS::Device::get_device_speed", XS_USB__LibUSB__XS__Device_get_device_speed);
        newXS_deffile("USB::LibUSB::XS::Device::get_max_packet_size", XS_USB__LibUSB__XS__Device_get_max_packet_size);
        newXS_deffile("USB::LibUSB::XS::Device::get_max_iso_packet_size", XS_USB__LibUSB__XS__Device_get_max_iso_packet_size);
        newXS_deffile("USB::LibUSB::XS::Device::ref_device", XS_USB__LibUSB__XS__Device_ref_device);
        newXS_deffile("USB::LibUSB::XS::Device::unref_device", XS_USB__LibUSB__XS__Device_unref_device);
        newXS_deffile("USB::LibUSB::XS::Device::open", XS_USB__LibUSB__XS__Device_open);
        newXS_deffile("USB::LibUSB::XS::open_device_with_vid_pid", XS_USB__LibUSB__XS_open_device_with_vid_pid);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::DESTROY", XS_USB__LibUSB__XS__Device__Handle_DESTROY);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::close", XS_USB__LibUSB__XS__Device__Handle_close);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_device", XS_USB__LibUSB__XS__Device__Handle_get_device);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_configuration", XS_USB__LibUSB__XS__Device__Handle_get_configuration);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::set_configuration", XS_USB__LibUSB__XS__Device__Handle_set_configuration);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::claim_interface", XS_USB__LibUSB__XS__Device__Handle_claim_interface);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::release_interface", XS_USB__LibUSB__XS__Device__Handle_release_interface);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::set_interface_alt_setting", XS_USB__LibUSB__XS__Device__Handle_set_interface_alt_setting);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::clear_halt", XS_USB__LibUSB__XS__Device__Handle_clear_halt);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::reset_device", XS_USB__LibUSB__XS__Device__Handle_reset_device);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::kernel_driver_active", XS_USB__LibUSB__XS__Device__Handle_kernel_driver_active);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::detach_kernel_driver", XS_USB__LibUSB__XS__Device__Handle_detach_kernel_driver);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::attach_kernel_driver", XS_USB__LibUSB__XS__Device__Handle_attach_kernel_driver);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::set_auto_detach_kernel_driver", XS_USB__LibUSB__XS__Device__Handle_set_auto_detach_kernel_driver);
        newXS_deffile("USB::LibUSB::XS::libusb_has_capability", XS_USB__LibUSB__XS_libusb_has_capability);
        newXS_deffile("USB::LibUSB::XS::libusb_error_name", XS_USB__LibUSB__XS_libusb_error_name);
        newXS_deffile("USB::LibUSB::XS::libusb_get_version", XS_USB__LibUSB__XS_libusb_get_version);
        newXS_deffile("USB::LibUSB::XS::libusb_setlocale", XS_USB__LibUSB__XS_libusb_setlocale);
        newXS_deffile("USB::LibUSB::XS::libusb_strerror", XS_USB__LibUSB__XS_libusb_strerror);
        newXS_deffile("USB::LibUSB::XS::Device::get_device_descriptor", XS_USB__LibUSB__XS__Device_get_device_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::get_active_config_descriptor", XS_USB__LibUSB__XS__Device_get_active_config_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::get_config_descriptor", XS_USB__LibUSB__XS__Device_get_config_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::get_config_descriptor_by_value", XS_USB__LibUSB__XS__Device_get_config_descriptor_by_value);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_bos_descriptor", XS_USB__LibUSB__XS__Device__Handle_get_bos_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_string_descriptor_ascii", XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor_ascii);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_descriptor", XS_USB__LibUSB__XS__Device__Handle_get_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::get_string_descriptor", XS_USB__LibUSB__XS__Device__Handle_get_string_descriptor);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::control_transfer_write", XS_USB__LibUSB__XS__Device__Handle_control_transfer_write);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::control_transfer_read", XS_USB__LibUSB__XS__Device__Handle_control_transfer_read);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::bulk_transfer_write", XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_write);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::bulk_transfer_read", XS_USB__LibUSB__XS__Device__Handle_bulk_transfer_read);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::interrupt_transfer_write", XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_write);
        newXS_deffile("USB::LibUSB::XS::Device::Handle::interrupt_transfer_read", XS_USB__LibUSB__XS__Device__Handle_interrupt_transfer_read);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
